<id>
More board/category options: icon for boards/cats, passwords for boards
</id>

<version>
1.2 SP
</version>

<mod info>
The mod gives you a new link on the admin-Center: More Options for Boards/Categories
It allows you to
1. Passwort protect boards
2. Set an icon for every board/category which will be displayed on the BoardIndex


Install intructions:
UPDATE from version 1.0: Uninstall version 1.0 and install 1.1, replace MBCoptions.pl also
1. Place the MBCoptions.pl in your /Sources directory and chmod it 755
2. Place the locking.gif and lockopen.gif in your /YaBBImages directory
3. Install this mod as usual

Manual:
Password protection for boards and icons for boards/categories can be set on the 
"More options for Boards/Categories" page accessable from the admin-center, 
section "Forum Controls". 
Password protection: 
A lock (open or closed) next to the boardname on the boardindex indicates that this board is protected. If a user clicks on the boardname he/she will be asked for the password. If the correct password is entered, the board will be unlocked, indicated by an open lock. The user can now view/post on this board. The board is be unlock till the user logs off YaBB. There's not option to log off a specific board. Guest are not allowed to log in protected boards. This COULD be added, but makes it more complicated. Tell me if you REALLY NEED this feature. Icons for Boards/Categories: 
Should be obvious ;) Icons must be placed in the /YaBBImages dir.

Version History:
0.1: First private release
0.2: Bug fixed: Direct URL to Post new thread on a protected board didn't ask for the password
     Small cosmetic change of icon placement
0.3: Cookie management impleted
0.4: Securiy hole fixed (thanks to DaveB!): Password was stored in cookie UNencrypted
0.5: Getting closer to 1.0 ;) Another security hole fixed: Cookie was set to never expire. If a user forgets to logout, the cookie never gets deleted (i.e. never expires). Now, cookie expiration is set to the default value.
1.0: Better handling of guests (Thanks to Blacky!)
     Small bug on enter password page fixed (Thanks to Starmartyr and Blacky!)
     Password field is "censored" now (with "*")
1.1: Bug fixes: 
     - Better LogOut handling. Some reported getting a 404 error on Logout,     fixed now
     - Category icon is set to "nothing" after deleting it
     - Layout: No space before the Board/category without an icon set anymore
     - Removed unnecessary censoring of thread number
     - Layout: Better icon alignement (thanks Godai!)
     - Topic summary is not shown anymore with new threads
1.1 SP: Nothing New really:
     - Now Compatible with SP thanks to omario
1.2 SP1.1: Bug Fixes
     - Login/Out Bug Fixed Thanks to Bluecloud
     - Profile.pl Bug Fixed
     - SP1.1 Compatible :) 

</mod info>

<author>
cae, sp1 conversion - omario
</author>

<homepage>
http://boardmod.xnull.com/yabb/YaBB.pl?board=newmods&action=viewprofile&username=cae, http://www.clickopedia.com
</homepage>

<edit file>
Sources/Admin.pl
</edit file>

<search for>
        - <a href="$cgi;action=manageboards">$txt{'4'}</a>
</search for>

<replace>
        - <a href="$cgi;action=manageboards">$txt{'4'}</a><br>
        - <a href="$cgi;action=morebcoptions">More Board/Category options</a><br>
</replace>

<edit file>
YaBB.pl
</edit file>

<search for>
		elsif ($action eq 'modifyboard') { require "$sourcedir/ManageBoards.pl"; &ModifyBoard; }
</search for>

<add after>
		elsif ($action eq 'morebcoptions') { require "$sourcedir/MBCoptions.pl"; &MoreBCOptions; }
</add after>

<search for>
		elsif ($action eq 'ml') { require "$sourcedir/Admin.pl"; &ml; }
</search for>

<add after>
		elsif ($action eq 'mbcomodify')    { require "$sourcedir/MBCoptions.pl"; &mbcomodify; }
</add after>

<search for>
	elsif ($action eq 'clean_log') { require "$sourcedir/Admin.pl"; &clean_log; }
</search for>

<add after>
	elsif ($action eq 'checkboardpw2') {require "$sourcedir/MBCoptions.pl"; &checkboardpw; }
</add after>

<search for>
sub yymain {
</search for>

<add after>
### Start More Board and Category Options mod	
	my ($mbco_passw,$mbco_pic);	
	fopen(MBCO, "$boardsdir/$currentboard.mbo");
	@configs = <MBCO>;
	fclose(MBCO);
	($mbco_passw,$dummyxx) = split(/\|/, $configs[0]);
	foreach (split(/; /,$ENV{'HTTP_COOKIE'})) {
		$_ =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		($cookie,$value) = split(/=/);
		$yyCookies{$cookie} = $value;
		
	}
	$forboardpw = "$cookiepassword$currentboard";
	$forboard = "$cookieusername$currentboard";
	$crypass=crypt($mbco_passw,$pwseed);
	if ($yyCookies{$forboardpw} eq $crypass) {$requestsender="Showask";}
	if($mbco_passw && $requestsender ne "Showask" && !$FORM{'boardpw'} ) {
		$requestsender = "Subs";
		require "$sourcedir/MBCoptions.pl"; 
		&askforboardpw("$currentboard");
		}
### End More Board and Category Options mod
</add after>

<edit file>
Sources/BoardIndex.pl
</edit file>

<search for>
	foreach $curcat (@categories) {
		unless( $openmemgr{$curcat} ) { next; }
</search for>

<add after>
		####
		
		fopen(MBCO, "$boardsdir/$curcat.mco");
		@messages = <MBCO>;
		fclose(MBCO);
		$mbco_cpic=$messages[0];
		$caticon="";
		if ($mbco_cpic) {$caticon= qq~<img border="0" alt="" align="absmiddle" src="$imagesdir/$mbco_cpic">&nbsp;~;}
		####
</add after>

<search for>
			chomp $curboardmods;
			fclose(FILE);
</search for>

<add after>
			#####
			fopen(MBCO, "$boardsdir/$curboard.mbo");
			@messages = <MBCO>;
			fclose(MBCO);
			($mbco_passw,$mbco_pic) = split(/\|/, $messages[0]);
			$boardpwpic="";
			$boardicon="";
			if($mbco_pic) {$boardicon = qq~<img border="0" align="absmiddle" alt="" src="$imagesdir/$mbco_pic">&nbsp;~;}
			if($mbco_passw) {
				$boardpwpic = qq~<img border="0" alt="" align="absmiddle" src="$imagesdir/locking.gif">~;
				$forboardpw = "$cookiepassword$curboard";
				### Check if the user has already logged in this board
				$crypass=crypt($mbco_passw,$pwseed);
				if ($yyCookies{$forboardpw} eq $crypass) {$boardpwpic = qq~<img border="0" align="absmiddle" alt="" src="$imagesdir/lockopen.gif">~;} 
				}
			#####
</add after>

<search for>
        <font size=2><a href="$scripturl?board=$curboard"><B>$curboardname</B></a></font>
</search for>

<replace>
        <font size=2><a href="$scripturl?board=$curboard"><B>$boardicon$curboardname $boardpwpic</B></a></font>
</replace>

<search for>
        <td colspan="5" class="catbg" bgcolor="$color{'catbg'}" height="18"><a name="$curcat"> <font size=2><b>$catname{$curcat}</b></font></a></td>
</search for>

<replace>
        <td colspan="5" class="catbg" bgcolor="$color{'catbg'}" height="18"><a name="$curcat"> <font size=2>$caticon <b>$catname{$curcat}</b></font></a></td>
</replace>

<edit file>
english.lng
</edit file>

<search for>
if($MenuType == 1) {
</search for>

<add before>
$mbco{'1'} = "More Board/Category Options";
$mbco{'2'} = "Lets you<li>password protect boards</li><li>select an individual image for each board/category<br>Images for boards and categories must be placed in your $imagesdir directory!</li>";
$mbco{'3'} = "Password";
$mbco{'4'} = "Pic";
$mbco{'5'} = "Set category pic";
$mbco{'6'} = "Set board password";
$mbco{'7'} = "Set board pic";
$mbco{'8'} = "Current pic:";
$mbco{'9'} = "Enter password";
$mbco{'10'} = "Submit";
$mbco{'11'} = "for the board";
$mbco{'12'} = "Wrong password!";
$mbco{'13'} = "Post in password protected board. Cannot display.";
$mbco{'14'} = "[pw protected]";
$mbco{'15'} = "Board is password-protected. You have to be logged in to log in this board!";

</add before>

<edit file>
Sources/Search.pl
</edit file>

<search for>
		foreach (@censored) {
			($tmpa,$tmpb) = @{$_};
			$message =~ s~\Q$tmpa\E~$tmpb~gi;
			$msub =~ s~\Q$tmpa\E~$tmpb~gi;
		}
</search for>

<add after>
		####
		fopen(MBCO, "$boardsdir/$board.mbo");
		@lines = <MBCO>;
		fclose(MBCO);
		($mbco_passw,$mbco_pic) = split(/\|/, $lines[0]);
		$forboardpw = "$cookiepassword$board";
		$crypass=crypt($mbco_passw,$pwseed);
		if($mbco_passw && $yyCookies{$forboardpw} ne $crypass) {
			$message = $mbco{'13'};
			$msub = $mbco{'14'};
			#$tnum = $mbco{'14'};
			}
		####
</add after>

<edit file>
Sources/Profile.pl
</edit file>

<search for>
		($board, $tnum, $c, $msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $message, $mns) = @{ $data{$messages[$i]} };
		foreach (@censored) {
			($tmpa,$tmpb) = @{$_};
			$message =~ s~\Q$tmpa\E~$tmpb~gi;
			$msub =~ s~\Q$tmpa\E~$tmpb~gi;
		}
</search for>

<add after>
		####
		fopen(MBCO, "$boardsdir/$board.mbo");
		@lines = <MBCO>;
		fclose(MBCO);
		($mbco_passw,$mbco_pic) = split(/\|/, $lines[0]);
		
		$forboardpw = "$cookiepassword$board";
		$crypass=crypt($mbco_passw,$pwseed);
		if($mbco_passw && $yyCookies{$forboardpw} ne $crypass) {
			$message = $mbco{'13'};
			$msub = $mbco{'14'};
			#$tnum = $mbco{'14'};
			}
		####
</add after>

<edit file>
Sources/Recent.pl
</edit file>

<search for>
			$totaltime = stringtotime($datetime);
			$data{$totaltime}= $post;
</search for>

<add after>
			####
			fopen(MBCO, "$boardsdir/$curboard.mbo");
			@messages = <MBCO>;
			fclose(MBCO);
			($mbco_passw,$mbco_pic) = split(/\|/, $messages[0]);
			
			$forboardpw = "$cookiepassword$curboard";
			$crypass=crypt($mbco_passw,$pwseed);
			if($mbco_passw && $yyCookies{$forboardpw} ne $crypass) { 
				$data{$totaltime}= "<br>$txt{'235'}: $mbco{'13'}<br>$txt{'791'} <A href=\"$scripturl?action=recent\">$txt{'792'}</a> $txt{'793'}";
				}
		
			####
</add after>

<search for>
		&wrap;
</search for>

<add before>
		####
		fopen(MBCO, "$boardsdir/$board.mbo");
		@lines = <MBCO>;
		fclose(MBCO);
		($mbco_passw,$mbco_pic) = split(/\|/, $lines[0]);
		$forboardpw = "$cookiepassword$board";
		$crypass=crypt($mbco_passw,$pwseed);
		if($mbco_passw && $yyCookies{$forboardpw} ne $crypass) {
			$message = $mbco{'13'};
			$msub = $mbco{'14'};
			#$tnum = $mbco{'14'};
			}
		####
</add before>

<edit file>
Sources/LogInOut.pl
</edit file>

<search for>
	$username = 'Guest';
</search for>

<add before>
### START More Board+Cat Options 1.1 SP1 - Security Fix 2.0 ###
	opendir (DIR,"$boardsdir");
	foreach (readdir DIR) {
	    if ($_ =~ /\.mbo/i) {   #for each protected board
		$forboardpw = "$cookiepassword$`";
		$forboard = "$cookieusername$`";
		push @otherCookies, cookie(-name    =>   "$forboard",
					-value   =>   "",
					-path    =>   "/",
					-expires =>   "Thursday, 01-Jan-1970 00:00:00 GMT");
		push @otherCookies, cookie(-name    =>   "$forboardpw",
					-value   =>   "",
					-path    =>   "/",
					-expires =>   "Thursday, 01-Jan-1970 00:00:00 GMT");
	    }
	}
	closedir DIR;
###  END  More Board+Cat Options 1.1 SP1 - Security Fix 2.0##
</add before>

<edit file>
Sources/Subs.pl
</edit file>

<search for>
	if($yySetCookies1 || $yySetCookies2) { print header(-cookie=>[$yySetCookies1, $yySetCookies2], -charset=>'$yycharset'); }
	else { print header(-status=>'200 OK', -charset=>'$yycharset'); }
</search for>

<replace>
	if($yySetCookies1 || $yySetCookies2 || scalar @otherCookies) { print header(-cookie=>[$yySetCookies1, $yySetCookies2, @otherCookies], -charset=>'$yycharset'); }
	else { print header(-status=>'200 OK', -charset=>'$yycharset'); }
</replace>